//+------------------------------------------------------------------+
//|                                             DataCollector v1.mq4 |
//|                                                        bazmonaut |
//+------------------------------------------------------------------+
#property copyright "bazmonaut"
#property link      ""

double open, high, low, close, volume;
double ADX, ADXplus, ADXminus, H4ADX, H4ADXplus, H4ADXminus;
double bodyheight, totalheight, wickpercent;
int    year, month, date, dayofweek, hour, minute, second;
datetime oldtime;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

   oldtime = Time[0];

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   
// check if this tick is for a new candle
   if (oldtime < Time[0])
      {
      // collect data for last candle
      year = TimeYear(oldtime);
      month = TimeMonth(oldtime);
      date = TimeDay(oldtime);
      dayofweek = TimeDayOfWeek(oldtime);
      hour = TimeHour(oldtime);
      
      open = iOpen(Symbol(),0,1);
      high = iHigh(Symbol(),0,1);
      low = iLow(Symbol(),0,1);
      close = iClose(Symbol(),0,1);
            
      volume = iVolume(Symbol(),0,1);
      
      ADX = iADX(Symbol(),0,14,4,0,1);
      ADXplus = iADX(Symbol(),0,14,4,1,1);
      ADXminus = iADX(Symbol(),0,14,4,2,1);
      
      H4ADX = iADX(Symbol(),PERIOD_H4,14,4,0,1);
      H4ADXplus = iADX(Symbol(),PERIOD_H4,14,4,1,1);
      H4ADXminus = iADX(Symbol(),PERIOD_H4,14,4,2,1);
                  
      bodyheight = MathAbs(open - close) * 10000;
      totalheight = MathAbs( high - low) * 10000;
      wickpercent = MathAbs((totalheight - bodyheight)/totalheight);
      
      // print values into log file
      PrintValues();
      
      // reset value of oldime
         oldtime = Time[0];
      }
      
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

void PrintValues()
   {
   Print(",symbol:,",Symbol(),
         ",timeframe:,",Period(),
         ",year:,",year,
         ",month:,",month,
         ",date:,",date,
         ",dayofweek:,",dayofweek,
         ",hour:,",hour,
         ",open:,",open,
         ",high:,",high,
         ",low:,",low,
         ",close:,",close,
         ",volume:,",volume,
         ",bodyheight:,",bodyheight,
         ",totalheight:,",totalheight,
         ",wickpercent:,",wickpercent,
         ",ADX:,", ADX,
         ",ADXplus:,",ADXplus,
         ",ADXminus:,",ADXminus);
    
   return;
   }